datablock AudioProfile(BongoFuryFireSound)
{
    filename = "./Bongo Fury_fire.wav";
    description = AudioClose3d;
    preload = true;
};

AddDamageType("BongoFury",'<bitmap:add-ons/Weapon_Bongo_Fury/ci_Bongo Fury> %1','%2 <bitmap:add-ons/Weapon_Bongo_Fury/ci_Bongo Fury> %1',0.2,1);

datablock ParticleData(BongoFuryParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 0;
	spinRandomMin		= 0;
	spinRandomMax		= 0;
	colors[0]	= "1 1 0 0.1";
	colors[1]	= "1 1 0.4 0.08";
	colors[2]	= "0.7 0.7 0.7 0";
	sizes[0]	= 0.6;
	sizes[1]	= 0.4;
	sizes[2]	= 0.0;
	times[0]	= 0.1;
	times[1]	= 0.1;
	times[2]	= 1.0;
	windCoefficient = 0.0;
	useInvAlpha = false;
};

datablock ParticleEmitterData(BongoFuryEmitter)
{
	ejectionPeriodMS = 1.5;
	periodVarianceMS = 0;
	ejectionVelocity = 0.0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 89.999999;
	thetaMax         = 90;
	phiReferenceVel  = 36000;
	phiVariance      = 1;
	overrideAdvance = false;
	particles = "BongoFuryParticle";
	useEmitterColors = false;
	uiName = "";
};

datablock ParticleData(BongoFuryExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.3";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 1.5;
	sizes[1]      = 2;
	useInvAlpha = true;
};

datablock ParticleEmitterData(BongoFuryExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BongoFuryExplosionParticle";
   useEmitterColors = true;
};

datablock ParticleData(BongoFuryExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "1 1 0.0 0.4";
	colors[2]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 1.5;
	sizes[1]      = 2;
	sizes[2]      = 3;
	times[0] = 0.0;
	times[1] = 0.1;
	times[2] = 1;
	useInvAlpha = false;
};

datablock ParticleEmitterData(BongoFuryExplosionRingEmitter)
{
	lifeTimeMS = 50;
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 89;
	thetaMax         = 90;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "BongoFuryExplosionRingParticle";
	useEmitterColors = true;
};

datablock ExplosionData(BongoFuryExplosion)
{
	soundProfile = bulletHitSound;
	lifeTimeMS = 150;
	particleEmitter = BongoFuryExplosionEmitter;
	particleDensity = 5;
	particleRadius = 0;
	emitter[0] = BongoFuryExplosionRingEmitter;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = true;
	camShakeFreq = "10.0 11.0 10.0";
	camShakeAmp = "1.0 1.0 1.0";
	camShakeDuration = 0.5;
	camShakeRadius = 10.0;
	lightStartRadius = 0;
	lightEndRadius = 2;
	lightStartColor = "0.3 0.6 0.7";
	lightEndColor = "0 0 0";
	impulseRadius = 2;
	impulseForce = 1000;
};

datablock ProjectileData(BongoFuryProjectile)
{
	projectileShapeName = "add-ons/Vehicle_Tank/tankbullet.dts";
	directDamage        = 18;
	directDamageType = $DamageType::BongoFury;
	radiusDamageType = $DamageType::BongoFury;
	impactImpulse	   = 450;
	verticalImpulse	   = 200;
	explosion           = BongoFuryExplosion;
	particleEmitter	   = BongoFuryEmitter;
	muzzleVelocity      = 130;
	velInheritFactor    = 1.0;
	armingDelay         = 0;
	lifetime            = 2000;
	fadeDelay           = 1500;
	bounceElasticity    = 0.5;
	bounceFriction      = 0.20;
	isBallistic         = false;
	gravityMod = 0.0;
	explodeOnDeath = true;
	hasLight    = true;
	lightRadius = 4.0;
	lightColor  = "1 0.8 0.2";
	uiName = "Bongo Fury Bullet";
};

datablock ItemData(BongoFuryItem)
{
    category = "Weapon";
    className = "Weapon";
    shapeFile = "./bongo both.dts";
    rotate = false;
    mass = 1;
    density = 0.2;
    elasticity = 0.2;
    friction = 0.6;
    emap = true;
    uiName = "Bongo Fury";
    iconName = "./icon_Bongo Fury";
    doColorShift = true;
    colorShiftColor = "1.000 1.000 1.000 1.000";
    image = BongoFuryRightImage;
    canDrop = true;
};

datablock ShapeBaseImageData(BongoFuryRightImage)
{
	shapeFile = "./bongo right.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = eulerToMatrix( "0 0 0" );
	correctMuzzleVector = true;
	className = "WeaponImage";
	item = BongoFuryItem;
	ammo = " ";
	projectile = BongoFuryProjectile;
	projectileType = Projectile;
	casing = gunShellDebris;
	shellExitDir = "1.0 -1.3 1.0";
	shellExitOffset = "0 0 0";
	shellExitVariance = 15.0;	
	shellVelocity = 7.0;
	melee = false;
	armReady = true;
	doColorShift = true;
	colorShiftColor = BongoFuryRightItem.colorShiftColor;
   
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.3;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
	stateEjectShell[2] = true;
	stateTransitionOnTimeout[2] = "Smoke";
	stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.09;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateEmitter[2] = gunFlashEmitter;
	stateEmitterTime[2] = 0.2;
	stateEmitterNode[2] = "muzzleNode";

	stateName[3] = "Smoke";
	stateEmitter[3] = gunSmokeEmitter;
	stateEmitterTime[3] = 0.15;
	stateEmitterNode[3] = "muzzleNode";
	stateTimeoutValue[3] = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4] = "Reload";
	stateAllowImageChange[4] = false;
	stateTransitionOnTriggerUp[4] = "FireAkimbo";

	stateName[5] = "FireAkimbo";
	stateTimeoutValue[5] = 0.4;
	stateScript[5] = "onFireAkimbo";
	stateTransitionOnTimeOut[5] = "ready";
};

datablock ShapeBaseImageData(BongoFuryLeftImage)
{
	shapeFile = "./bongo left.dts";
	emap = true;
	mountPoint = 1;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = eulerToMatrix( "0 0 0" );
	correctMuzzleVector = true;
	className = "WeaponImage";
	item = BongoFuryItem;
	ammo = " ";
	projectile = BongoFuryProjectile;
	projectileType = Projectile;
	casing = gunShellDebris;
	shellExitDir = "1.0 -1.3 1.0";
	shellExitOffset = "0 0 0";
	shellExitVariance = 15.0;	
	shellVelocity = 7.0;
	melee = false;
	armReady = false;
	doColorShift = true;
	colorShiftColor = BongoFuryLeftItem.colorShiftColor;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.3;
	stateSound[0] = weaponSwitchSound;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
	stateEjectShell[2] = true;
	stateTransitionOnTimeout[2] = "Smoke";
	stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.09;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateEmitter[2] = gunFlashEmitter;
	stateEmitterTime[2] = 0.2;
	stateEmitterNode[2] = "muzzleNode";

	stateName[3] = "Smoke";
	stateEmitter[3] = gunSmokeEmitter;
	stateEmitterTime[3] = 0.15;
	stateEmitterNode[3] = "muzzleNode";
	stateTimeoutValue[3] = 0.4;
	stateTransitionOnTimeout[3] = "Reload";

	stateName[4] = "Reload";
	stateAllowImageChange[4] = false;
	stateTransitionOnTriggerUp[4] = "Ready";
};

function BongoFuryRightImage::onFire(%this,%obj,%slot)
{
	%projectile = BongoFuryProjectile;
	%spread = 0.001;
	%vector1 = VectorScale(%obj.getMuzzleVector(%slot), %projectile.muzzleVelocity);
	%vector2 = VectorScale(%obj.getVelocity(), %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);
	%p = new Projectile()
	{
		dataBlock = %projectile;
		client = %obj.client;
		initialPosition = %obj.getMuzzlePoint(%slot);
		initialVelocity = %velocity;
		sourceObject = %obj;
		sourceSlot = %slot;
	};
	serverPlay3D(BongoFuryFireSound,%obj.getPosition());
	%obj.playThread(2, shiftAway);
	%obj.spawnExplosion(BongoFuryRecoilProjectile,"1 1 1");
	MissionCleanup.add(%p);
	return %p;
}

function BongoFuryRightImage::onFireAkimbo(%this,%obj,%slot)
{
	%obj.setImageTrigger(1,1);
}

function BongoFuryRightImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
	%obj.mountImage(BongoFuryLeftImage, 1);
}

function BongoFuryRightImage::onUnMount(%this, %obj, %slot)
{
	Parent::onUnMount(%this, %obj, %slot);
	%obj.unMountImage(1);
}

function BongoFuryLeftImage::onFire(%this,%obj,%slot)
{
	%projectile = BongoFuryProjectile;
	%spread = 0.001;
	%vector1 = VectorScale(%obj.getMuzzleVector(%slot), %projectile.muzzleVelocity);
	%vector2 = VectorScale(%obj.getVelocity(), %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);
	%p = new Projectile()
	{
		dataBlock = %projectile;
		client = %obj.client;
		initialPosition = %obj.getMuzzlePoint(%slot);
		initialVelocity = %velocity;
		sourceObject = %obj;
		sourceSlot = %slot;
	};
	serverPlay3D(BongoFuryFireSound,%obj.getPosition());
	%obj.playThread(2, leftrecoil);
	%obj.spawnExplosion(BongoFuryRecoilProjectile,"1 1 1");
	MissionCleanup.add(%p);
	return %p;
}

function BongoFuryLeftImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
	%obj.playThread(1, armreadyboth);
}

function BongoFuryLeftImage::onUnMount(%this, %obj, %slot)
{
	Parent::onUnMount(%this, %obj, %slot);
}